#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <time.h>

#define	uleft	04040
#define	uright	04004
#define	dleft	00440
#define	dright	00404
#define	left	00040
#define	right	00004
#define	up	04000
#define	down	00400
#define	u2r1	06004
#define	u1r2	04006
#define	d1r2	00406
#define	d2r1	00604
#define	d2l1	00640
#define	d1l2	00460
#define	u1l2	04060
#define	u2l1	06040
#define	rank2	00200
#define	rank7	02000

#define	none	012345

struct	att	{
	int	p_mask;
	int	p_off;
};

struct	satt	{
	int	s_mask;
	int	s_off;
	int	s_pawn;
	int	s_check;
};

struct obj {
	int	o_1;
	int	o_2;
};

extern	void bagen(void);
extern	void btry(register int from, register int mask, register int offset);
extern	int bcheck(register int from, register int to);
extern	void wagen(void);
extern	void wtry(register int from, register int mask, register int offset);
extern	int wcheck(register int from, register int to);
extern	int battack(register int n);
extern	int wattack(register int n);
extern	int badiag(register int d, register int off, register int i);
extern	int barank(register int d, register int off, register int i);
extern	int wadiag(register int d, register int off, register int i);
extern	int warank(register int d, register int off, register int i);
extern	void bgen(void);
extern	void b_try(register int m, register int o);
extern	void bslide(register int m, register int o);
extern	int bheur1(void);
extern	int bheur2(void);
extern	int bheur3(void);
extern	int bheur4(void);
extern	int bheur5(void);
extern	int bheur6(void);
extern	void bmove(register int pos);
extern	void bremove(void);
extern	int bookm(void);
extern	void makmov(register int m);
extern	int booki(register short m);
extern	int bplay(void);
extern	int bplay1(register int ab);
extern	int bquies(register int ab);
extern	void attack(register int n);
extern	void mytime(register char *s, register int t);
extern	int check(void);
extern	void increm(void);
extern	void decrem(void);
extern	void stage(void);
extern	void posit(register void (*f)(register int, register int *), register int *p, register int *a);
extern	void rept1(register int m, register int *a);
extern	int rept(void);
extern	void rline(void);
extern	void pboard(void);
extern	void out1(register int m, register int *dummy);
extern	void out(register int m);
extern	void stdp(register int p);
extern	void stdb(register int b);
extern	void algco(register int p);
extern	void prtime(register int a, register int b);
extern	void score1(register int m, register int *dummy);
extern	void score(void);
extern	int mate(register int n, register int f);
extern	int mater(register int ns);
extern	int xmater(register int ns);
extern	void play(register int f);
extern	void move(void);
extern	int manual(void);
extern	int algin(void);
extern	int cooin(void);
extern	int match(register char *s);
extern	int *done(void);
extern	int xplay(void);
extern	void term(void);
extern	void mysort(register struct obj *p1, register struct obj *p2);
extern	void save(void);
extern	void restore(void);
extern	void setup(void);
extern	int *statl(void);
extern	int wstatic(register int f);
extern	int bstatic(register int f);
extern	int xheur(register int ploc);
extern	void srnd(register int p);
extern	void srnd1(register int p, register int m, register int o);
extern	int std_in(void);
extern	void stdpin(register int *ap, register int *as, register int *ar, register int *af);
extern	void stdbin(register int *as, register int *ar, register int *af);
extern	int pcomp(register int p, register int l, register int pp, register int sp, register int rp, register int fp);
extern	int comp(register int p, register int v);
extern	int abs(register int x);
extern	void w_try(register int m, register int o);
extern	void wslide(register int m, register int o);
extern	void wgen(void);
extern	int wheur1(void);
extern	int wheur2(void);
extern	int wheur3(void);
extern	int wheur4(void);
extern	int wheur5(void);
extern	int wheur6(void);
extern	void wmove(register int pos);
extern	void wremove(void);
extern	int wplay(void);
extern	int wplay1(register int ab);
extern	int wquies(register int ab);

struct att patt[7] = {
	u2r1, -15,
	u1r2,  -6,
	d2r1,  17,
	d2l1,  15,
	d1l2,   6,
	u1l2, -10,
	u2l1, -17
};

struct	satt	satt[8] = {
	uleft,  -9,    1, 3,
	uright, -7,    1, 3,
	dleft,   7,   -1, 3,
	dright,  9,   -1, 3,
	up,     -8, none, 4,
	left,   -1, none, 4,
	right,   1, none, 4,
	down,    8, none, 4
};

int	center[] =
{
	2,3,4,4,4,4,3,2,
	3,6,8,8,8,8,6,3,
	4,8,12,12,12,12,8,4,
	4,8,12,14,14,12,8,4,
	4,8,12,14,14,12,8,4,
	4,8,12,12,12,12,8,4,
	3,6,8,8,8,8,6,3,
	2,3,4,4,4,4,3,2
};

int	(*wheur[])(void) =
{
	wheur1,
	wheur2,
	wheur3,
	wheur4,
	wheur5,
	wheur6,
	0
};

int	(*bheur[])(void) =
{
	bheur1,
	bheur2,
	bheur3,
	bheur4,
	bheur5,
	bheur6,
	0
};

int	ipval[] =
{
	-3000, -900, -500, -300, -300, -100,
	0,
	100, 300, 300, 500, 900, 3000
};

int	moveno	=1;
int	depth	=2;
int	qdepth	=8;
int	mdepth	=4;
int	flag	=033;
int	eppos	=64;
int	bkpos	=4;
int	wkpos	=60;

int	edge[] =
{
	040, 020, 010, 0, 0, 1, 2, 4
};

int	board[] =
{
	4, 2, 3, 5, 6, 3, 2, 4,
	1, 1, 1, 1, 1, 1, 1, 1,
	0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0,
	-1, -1, -1, -1, -1, -1, -1, -1,
	-4, -2, -3, -5, -6, -3, -2, -4,
};

int	attacv[64];
int	control[64];
int	clktim[2];
int	testf;
int	bookf;
short	bookp;
int	manflg;
int	matflg;
int	intrp;
int	gval;
int	game;
int	abmove;
int	*lmp;
int	*amp;
char	*sbufp;
int	lastmov;
int	mantom;
int	ply;
int	value;
int	ivalue;
int	mfmt;
int	pval[13];
int	dir[64];
int	lmbuf[1000];
int	ambuf[1200];
char	sbuf[100];

/*	"locals" from bgen() which became globals
	upon some multi-line #defines being made
	into real function calls.
*/
int	*pb_bgen, *pd_bgen;
int	i_bgen;
int	*pb_wgen, *pd_wgen;
int	i_wgen;

void
onhup()
{
	exit(1);
}

void
abort()
{
	exit(2);
}

void
bagen(void)
{
	register int *p1, *p2, v;

	p1 = lmp;
	if((flag&010)!=0)
	if(board[5]==0 && board[6]==0 && board[7]==4)
	if(wattack(4) && wattack(5) && wattack(6))
		btry(4, 0, 2); /* kingside castle */
	if((flag&020)!=0)
	if(board[0]==4 && board[1]==0 && board[2]==0 && board[3]==0)
	if(wattack(2) && wattack(3) && wattack(4))
		btry(4, 0, -2); /* queenside castle */
	bgen();
	p2 = p1;
	while(p2 != lmp) {
		v = *p2++;
		bmove(*p2);
		if(wattack(bkpos)) {
			*p1++ = v;
			*p1++ = *p2;
		}
		p2++;
		bremove();
	}
	lmp = p1;
}

void
btry(register int from,
register int mask,
register int offset)
{

	if((dir[from]&mask)==0)
		bcheck(from, from+offset);
}

int
bcheck(register int from,
register int to)
{

	if(board[to]>0) return(1);
	*lmp++ = (pval+6)[board[to]]-value;
	*lmp++ = (from<<8)|to;
	return(board[to] != 0);
}

void
wagen(void)
{
	register int *p1, *p2, v;

	p1 = lmp;
	if((flag&1)!=0)
	if(board[61]==0 && board[62]==0 && board[63]== -4)
	if(battack(60) && battack(61) && battack(62))
		wtry(60, 0, 2); /* kingside castle */
	if((flag&2)!=0)
	if(board[56]== -4 && board[57]==0 && board[58]==0 && board[59]==0)
	if(battack(58) && battack(59) && battack(60))
		wtry(60, 0, -2); /* queenside castle */
	wgen();
	p2 = p1;
	while(p2 != lmp) {
		v = *p2++;
		wmove(*p2);
		if(battack(wkpos)) {
			*p1++ = v;
			*p1++ = *p2;
		}
		p2++;
		wremove();
	}
	lmp = p1;
}

void
wtry(register int from,
register int mask,
register int offset)
{

	if((dir[from]&mask)==0)
		wcheck(from, from+offset);
}

int
wcheck(register int from,
register int to)
{

	if(board[to]<0) return(1);
	*lmp++ = value-(pval+6)[board[to]];
	*lmp++ = (from<<8)|to;
	return(board[to] != 0);
}

int
battack(register int n)
{
	register int m, t;

	m = dir[n];
	t = 2;
	if((m & u2r1) == 0 && board[n-15] == t)
		return(0);
	if((m & u1r2) == 0 && board[n- 6] == t)
		return(0);
	if((m & d1r2) == 0 && board[n+10] == t)
		return(0);
	if((m & d2r1) == 0 && board[n+17] == t)
		return(0);
	if((m & d2l1) == 0 && board[n+15] == t)
		return(0);
	if((m & d1l2) == 0 && board[n+ 6] == t)
		return(0);
	if((m & u1l2) == 0 && board[n-10] == t)
		return(0);
	if((m & u2l1) == 0 && board[n-17] == t)
		return(0);

	if(badiag(uleft, -9, n))
		return(0);
	if(badiag(uright, -7, n))
		return(0);
	if(badiag(dleft, 7, n))
		return(0);
	if(badiag(dright, 9, n))
		return(0);
	if(barank(up, -8, n))
		return(0);
	if(barank(left, -1, n))
		return(0);
	if(barank(right, 1, n))
		return(0);
	if(barank(down, 8, n))
		return(0);
	if((m & uleft) == 0 && board[n- 9] == 1)
		return(0);
	if((m & uright) == 0 && board[n- 7] == 1)
		return(0);
	return(1);
}

int
wattack(register int n)
{
	register int m, t;

	m = dir[n];
	t = -2;
	if((m & u2r1) == 0 && board[n-15] == t)
		return(0);
	if((m & u1r2) == 0 && board[n- 6] == t)
		return(0);
	if((m & d1r2) == 0 && board[n+10] == t)
		return(0);
	if((m & d2r1) == 0 && board[n+17] == t)
		return(0);
	if((m & d2l1) == 0 && board[n+15] == t)
		return(0);
	if((m & d1l2) == 0 && board[n+ 6] == t)
		return(0);
	if((m & u1l2) == 0 && board[n-10] == t)
		return(0);
	if((m & u2l1) == 0 && board[n-17] == t)
		return(0);

	if(wadiag(uleft, -9, n))
		return(0);
	if(wadiag(uright, -7, n))
		return(0);
	if(wadiag(dleft, 7, n))
		return(0);
	if(wadiag(dright, 9, n))
		return(0);
	if(warank(up, -8, n))
		return(0);
	if(warank(left, -1, n))
		return(0);
	if(warank(right, 1, n))
		return(0);
	if(warank(down, 8, n))
		return(0);
	if((m & dleft) == 0 && board[n + 9] == -1)
		return(0);
	if((m & dright) == 0 && board[n + 7] == -1)
		return(0);
	return(1);
}

int
badiag(register int d,
register int off,
register int i)
{
	register int j;

	if(dir[i] & d)
		return(0);
	i += off;
	switch(board[i]){
	default:
		return(0);
	case 3:
	case 5:
	case 6:
		return(1);
	case 0:
		break;
	}
	do {
		if(dir[i] & d)
			return(0);
	} while((j = board[i += off]) == 0);
	return(j == 3 || j == 5);
}

int
barank(register int d,
register int off,
register int i)
{
	register int j;

	if(dir[i] & d)
		return(0);
	i += off;
	switch(board[i]){
	default:
		return(0);
	case 4:
	case 5:
	case 6:
		return(1);
	case 0:
		break;
	}
	do {
		if(dir[i] & d)
			return(0);
	} while((j = board[i += off]) == 0);
	return(j == 4 || j == 5);
}

int
wadiag(register int d,
register int off,
register int i)
{
	register int j;

	if(dir[i] & d)
		return(0);
	i += off;
	switch(board[i]){
	default:
		return(0);
	case -3:
	case -5:
	case -6:
		return(1);
	case 0:
		break;
	}
	do {
		if(dir[i] & d)
			return(0);
	} while((j = board[i += off]) == 0);
	return(j == -3 || j == -5);
}

int
warank(register int d,
register int off,
register int i)
{
	register int j;

	if(dir[i] & d)
		return(0);
	i += off;
	switch(board[i]){
	default:
		return(0);
	case -4:
	case -5:
	case -6:
		return(1);
	case 0:
		break;
	}
	do {
		if(dir[i] & d)
			return(0);
	} while((j = board[i += off]) == 0);
	return(j == -4 || j == -5);
}

#define	PAWN	1
#define	KNIGHT	2
#define	BISHOP	3
#define	ROOK	4
#define	QUEEN	5
#define	KING	6

void
bgen(void)
{
	pd_bgen = &dir[63];
	pb_bgen = &board[63];
	i_bgen = 63;
	while(i_bgen >= 0){
		switch(*pb_bgen){
		case PAWN:
			if((*pd_bgen & dleft) == 0){
				if(pb_bgen[7] < 0)
					b_try(0, 7);
				if(i_bgen + 7 == eppos)
					b_try(0, -1);
			}
			if((*pd_bgen & dright) == 0){
				if(pb_bgen[9] < 0)
					b_try(0, 9);
				if(i_bgen + 9 == eppos)
					b_try(0, 1);
			}
			if(pb_bgen[8])
				break;
			b_try(0, 8);
			if((*pd_bgen & rank7) && (pb_bgen[16] == 0))
				b_try(0, 16);
			break;
	
		case KNIGHT:
			b_try(u2r1, -15);
			b_try(u1r2, -6);
			b_try(d1r2, 10);
			b_try(d2r1, 17);
			b_try(d2l1, 15);
			b_try(d1l2, 6);
			b_try(u1l2, -10);
			b_try(u2l1, -17);
			break;
	
		case BISHOP:
			bslide(uleft, -9);
			bslide(uright, -7);
			bslide(dleft, 7);
			bslide(dright, 9);
			break;
	
		case ROOK:
			bslide(up, -8);
			bslide(down, 8);
			bslide(left, -1);
			bslide(right, 1);
			break;
	
		case QUEEN:
			bslide(uleft, -9);
			bslide(uright, -7);
			bslide(dleft, 7);
			bslide(dright, 9);
			bslide(up, -8);
			bslide(left, -1);
			bslide(right, 1);
			bslide(down, 8);
			break;
	
		case KING:
			b_try(uleft, -9);
			b_try(uright, -7);
			b_try(dleft, 7);
			b_try(dright, 9);
			b_try(up, -8);
			b_try(left, -1);
			b_try(right, 1);
			b_try(down, 8);
			break;
	
		default:
			if(*pb_bgen > 0){
				printf("bgen(): bad piece = %d\n", *pb_bgen);
				abort();
			}
			break;
		}
		pb_bgen--;
		pd_bgen--;
		i_bgen--;
	}
	return;
}


void
b_try(register int m,
register int o)
{
	register int j;

	if((*pd_bgen & m) == 0 && (j = pb_bgen[o]) <= 0){
		*lmp++ = (pval+6)[j] - value;
		*lmp++ = (o + i_bgen) | (i_bgen << 8);
		}
	}

void
bslide(register int m,
register int o)
{
	int	*spb_bgen, *spd_bgen;		/* For bslide define */

	spb_bgen = pb_bgen, spd_bgen = pd_bgen;
	while((*pd_bgen & m) == 0){
		pb_bgen += o, pd_bgen += o;
		if(*pb_bgen > 0) break;
		if(*pb_bgen < 0){
			*lmp++ = (pval+6)[*pb_bgen] - value;
			*lmp++ = (pb_bgen-board) | (i_bgen << 8);
			break;
			}
		*lmp++ = -value;
		*lmp++ = (pb_bgen-board) | (i_bgen << 8);
		}
	pb_bgen = spb_bgen, pd_bgen = spd_bgen;
	}


/*
 *	mobility
 *	1 for each potential move
 */

int
bheur1(void)
{

	return(-wheur1());
}

/*
 *	opening 'goodies'
 *	10 for each minor piece out
 *	-10 for blocking kq pawns
 */

int
bheur2(void)
{
	register int i, mt;

	i = 0;
	if(game > 2) return(i);
	mt = amp[-1];
	if(mt == 2 || mt == 3) i += 30;
	if(mt == 0) i -= 20;
	i += 9*((board[1] != 2)+
		(board[6] != 2));
	i += 8*((board[2] != 3)+
		(board[5] != 3));

	/*
	 * -10 for blocked central pawns
	 */
	if(board[11]==1 && board[11+8]!=0) i -= 10;
	if(board[12]==1 && board[12+8]!=0) i -= 10;
	return(i);
}

/*
 *	ability to castle
 *	22 for both flags
 *	20 for one flag
 */

int
bheur3(void)
{
	register int i;

	i = 0;
	/*
	 * queenside ability
	 */
	if(flag&020 && board[8]==1 && board[9]==1 && board[10]==1)
		i += 20;
	/*
	 *  kingside ability
	 */
	if(flag&010 && board[13]==1 && board[14]==1 && board[15]==1)
		i += 20;
	/*
	 * if both
	 */
	if(i == 40)
		i = 22;
	/*
	 * if castled,
	 * keep pawns in
	 */
	if(bkpos==2)
		if(board[10]==1 && (board[8]==1 || board[8+8]==1) &&
			(board[9]==1 || board[9+8]==1))
				i += 40;
	if(bkpos==6)
		if(board[13]==1 && (board[14]==1 || board[14+8]==1) &&
			(board[15]== -1 || board[15+8]== -1))
				i += 40;
	return(i);
}

/*
 *	prance
 *	a percentage if the
 *	piece on the move
 *	can be driven back
 *	by a smaller piece
 */

int
bheur4(void)
{
	register int *p1, *p2, ploc, i;

	if(amp[-1] != 1) return(0);
	ploc = amp[-3];
	if(board[ploc] == 1) return(0);
	if(xheur(ploc)) return(0);
	p1 = lmp;
	p2 = p1;
	wagen();
	i = 0;
	while(p2 != lmp) {
		p2++;
		wmove(*p2++);
		i = xheur(ploc);
		wremove();
		if(i)
			break;
	}
	lmp = p1;
	return(-i);
}

/*
 *	control
 *	center control
 *		opening
 *		beginning
 *	king control
 *		middle
 *		end
 */

int
bheur5(void)
{

	return(-wheur5());
}

/*
 * mate threat
 * bad to capture
 */

int
bheur6(void)
{
	register int i;

	*amp++ = -1;
	i = 0;
	if(battack(wkpos))
		if(mate(2, 0))
			i += 15;
	amp--;
	return(i);
}


#define	PAWN	1
#define	KNIGHT	2
#define	BISHOP	3
#define	ROOK	4
#define	QUEEN	5
#define	KING	6

void
bmove(register int pos)
{
	register int *pa;
	register int to, from;

#ifdef	MAKESLOW
	for (volatile int i=0; i<10000; ++i) ;
#endif

	to = pos & 0377;
	from = (pos >> 8) & 0377;
	pa = amp;
	*pa++ = value;
	*pa++ = flag;
	*pa++ = eppos;
	*pa++ = from;
	*pa++ = to;
	if(*pa++ = board[to])
		value -= (pval+6)[board[to]];
	board[to] = board[from];
	board[from] = 0;
	eppos = -1;
	switch(board[to]){
	default:
		printf("Barfo in bmove -- piece moved = %d\n", board[to]);
		abort();
	case PAWN:
		if((from -= to) < 0)
			from = -from;
		if(from == 1){
			board[to] = 0;
			(board+8)[to] = PAWN;
			*pa++ = 4;
			amp = pa;
			return;
		}
		if(from == 16){
			eppos = ((pos >> 8) & 0377) + 8;
			goto move;
		}
		if(to < 40)
			goto move;
		value += 25;
		if(to < 48)
			goto move;
		value += 50;
		if(to < 56)
			goto move;
		value += 625;
		board[to] = QUEEN;
		*pa++ = 5;
		amp = pa;
		return;

	case ROOK:
		if(from == 7)
			flag &= ~010;
		else if(from == 0)
			flag &= ~020;
		goto move;

	case KING:
		bkpos = to;
		flag &= ~030;
		if(from == 4){
			if(to == 6){
				value++;
				board[5] = ROOK;
				board[7] = 0;
				*pa++ = 2;
				amp = pa;
				return;
			}
			if(to == 2){
				value++;
				board[3] = ROOK;
				board[0] = 0;
				*pa++ = 3;
				amp = pa;
				return;
			}
		}
		if(game == 0)
			value -= 2;
		*pa++ = 0;
		amp = pa;
		return;

	case QUEEN:
		if(game == 0)
			value--;
		/* Fall through */

	case KNIGHT:
	case BISHOP:
		{ move: ; }
		*pa++ = 1;
		amp = pa;
		return;
	}
}

void
bremove(void)
{
	register int *pa;
	register int to, from;
	int i;
	int oldpiece;

	pa = amp;
	i = *--pa;
	oldpiece = *--pa;
	to = *--pa;
	from = *--pa;
	eppos = *--pa;
	flag = *--pa;
	value = *--pa;
	amp = pa;
	board[from] = board[to];
	board[to] = oldpiece;
	switch(i){
	case 0:
		bkpos = from;
	case 1:
		return;
	case 2:
		board[7] = ROOK;
		board[5] = 0;
		bkpos = 4;
		return;
	case 3:
		board[0] = ROOK;
		board[3] = 0;
		bkpos = 4;
		return;
	case 4:
		board[from] = PAWN;
		(board+8)[to] = 0;
		return;
	case 5:
		board[from] = PAWN;
		return;
	default:
		printf("Barfo in bremove -- type %d\n", i);
		abort();
	}
}


int
bookm(void)
{
	register short  i;
	short  buf[2];

	if(!bookp) return(0);
	lseek(bookf, (long)(unsigned)bookp, 0);

	i = 0;
loop:
	read(bookf, buf, 4);
	*buf = booki(*buf);
	if(*buf >= 0) {
		if(!i)
			i = *buf;
		goto loop;
	}
	if(abmove = i)
		return(1);
	return(0);
}

void
makmov(register int m)
{
	short buf[2];

	out1(m, /* Missing arg set to 0 */ 0);
	mantom? bmove(m): wmove(m);
	increm();
	if(!bookp) return;
	lseek(bookf, (long)(unsigned)bookp, 0);

loop:
	read(bookf, buf, 4);
	*buf = booki(*buf);
	if(m == *buf || *buf == 0) {
		bookp = buf[1] & ~1;
		goto l1;
	}
	if(*buf < 0) {
		bookp = 0;
		goto l1;
	}
	goto loop;

l1:
	if(!bookp) {
		printf("\n");
		return;
	}
}

/*	MACHINE DEPENDENT STUFF

	The following structure is used to convert
	a binary 16-bit integer from the book file
	storage format to the integer representation
	used on your machine, in other words, it
	swaps bytes iff need be. Be sure it's right.
*/
typedef	struct {
#ifdef	ON_SEL
	char high;
	char low;
#else
	char low;
	char high;
#endif
	} shortbyt;

int
booki(short m)
{
	short i;
	register shortbyt *mp, *ip;

	ip = ((shortbyt *) &i);
	mp = ((shortbyt *) &m);
	ip->high = mp->low;
	ip->low = mp->high;
	return(i);
}


int
bplay(void)
{
	register int v1, v2, *p2, *p1;
	int *p3, ab;

	if(value > ivalue)
		ivalue = value;
	ab = 0;
	v1 = -3000;
	ply = 0;
	p1 = statl();
	if(lmp == p1+2) {
		abmove = p1[1];
		lmp = p1;
		return(ivalue);
	}
	p2 = p1;
	mantom = !mantom;
	while(p2 != lmp) {
		p2++;
		bmove(*p2);
		if(testf) {
			mantom = !mantom;
			bstatic(1);
			mantom = !mantom;
		}
		if(rept())
			v2 = 0; else
			v2 = wplay1(v1);
		if(v2 > v1 && !mate(3, 0)) {
			ab = *p2;
			v1 = v2;
		}
		bremove();
		if(testf) {
			mantom = !mantom;
			printf("%6d ", v2);
			out(*p2);
			printf("\n");
			mantom = !mantom;
		}
		p2++;
	}
	if(ab == 0 && lmp != p1)
		ab = p1[1];
	mantom = !mantom;
	lmp = p1;
	abmove = ab;
	return(v1);
}

int
bplay1(register int ab)
{
	register int v1, v2, *p1, *p2;

	if(ply >= depth)
		return(bquies(ab));
	ply++;
	p1 = p2 = lmp;
	bgen();
	mysort(((struct obj *) p1), ((struct obj *) lmp));
	v1 = -3000;
	while(p2 != lmp) {
		if(intrp)
			goto out;
		p2++;
		bmove(*p2);
		if(wattack(bkpos)) {
			v2 = wplay1(v1);
			if(v2 > v1)
				v1 = v2;
		}
		bremove();
		if(v1 >= ab)
			goto out;
		p2++;
	}
out:
	ply--;
	lmp = p1;
	if(v1 == -3000) {
		v1++;
		if(!check())
			v1 = 0;
	}
	return(v1);
}

int
bquies(register int ab)
{
	register int *p2, *p3, v2, v1;
	int *p1;

	if(ply >= qdepth)
		return(ivalue);
	p1 = p2 = p3 = lmp;
	bgen();
	while(p2 != lmp) {
		v1 = -(*p2++);
		if(v1 != value && v1 >= ivalue-50) {
			*p3++ = ((-(pval+6)[board[*p2>>8]]/100)<<8) |
				((pval+6)[board[*p2&0377]]/100);
			*p3++ = *p2;
		}
		p2++;
	}
	if(p3 == p1) {
		lmp = p1;
		return(value);
	}
	ply++;
	mysort(((struct obj *) p1), ((struct obj *) p3));
	lmp = p3;
	p2 = p1;
	v1 = value;
	while(p2 != lmp) {
		p2++;
		bmove(*p2);
		if(wattack(bkpos)) {
			v2 = wquies(v1);
		} else
			v2 = -3000;
		if(v2 > v1)
			v1 = v2;
		bremove();
		if(v1 >= ab)
			goto out;
		p2++;
	}
out:
	ply--;
	lmp = p1;
	return(v1);
}


void
attack(register int n)
{
	register int *pv;
	register int i;
	int *tmp;
	int offs;

	pv = attacv;
	for(i = 0; i < 7; i++){
		if((dir[n] & patt[i].p_mask) == 0){
			offs = patt[i].p_off + n;
			if(board[offs] == 2)
				*pv++ = 2;
			else if(board[offs] == -2)
				*pv++ = -2;
		}
	}
	for(i = 0; i < 8; i++){
		if((dir[n] & satt[i].s_mask) == 0){
			offs = satt[i].s_off + n;
			if(satt[i].s_pawn == board[offs])
				*pv++ = satt[i].s_pawn;
			offs = n;
			while((dir[n] & satt[i].s_mask) == 0){
				n += satt[i].s_off;
				if(board[n] == 0)
					continue;
				tmp = pv;
				if(board[n] == satt[i].s_check)
					*pv++ = satt[i].s_check;
				else	if(board[n] == -(satt[i].s_check))
						*pv++ = -(satt[i].s_check);
				else	if(board[n] == 5)
						*pv++ = 5;
				else	if(board[n] == -5)
						*pv++ = -5;
				if(tmp == pv)break;
			}
			n = offs;
		}
	}
	*pv++ = 0;
	return;
}

int
chessclock()
{
	static long t;
	long x;
	int r;

	time(&x);
	r = x - t;
	t = x;
	return(r);
}

int
main()
{
	register int i;

	/*
	 * Note that the following two printfs MUST always
	 * be included here, such that the two messages
	 * are printed each time PCHESS is run.
	 */
	printf("Portable Chess by John Buck PINY\n");
	printf("(Adapted from Bell's PDP11 version)\n");
	printf("(Ported to TRS-XENIX by Hank Dietz PINY)\n");
	printf("(Ported to Ubuntu by Hank Dietz UK)\n\n");

	lmp = lmbuf;
	amp = ambuf;
	*amp++ = -1;
	*lmp++ = -1;		/* fence */
	bookf = open("book", 0);
	if(bookf > 0)
		read(bookf, &bookp, 2);
	i = 64;
	while(i--)
		dir[i] = (edge[i/8]<<6) | edge[i%8];
	play(0);
}

void
mytime(register char *s,
register int t)
{

	printf("%s: %d:%d%d\n", s, t/60, (t/10)%6, t%10);
}

int
check(void)
{

	return((!wattack(bkpos) || !battack(wkpos))? 1: 0);
}

void
increm(void)
{

	clktim[mantom] += chessclock();
	if(mantom)
		moveno++;
	mantom = !mantom;
}

void
decrem(void)
{

	mantom = !mantom;
	if(mantom)
		moveno--;
}

void
stage(void)
{
	register int i, a;

	qdepth = depth+8;
	for(i=0; i<13; i++)
		pval[i] = ipval[i];
	value = 0;
	for(i=0; i<64; i++) {
		a = board[i];
		value += (pval+6)[a];
	}
	if(value > 150)
		gval = 1; else
	if(value < -150)
		gval = -1; else
		gval = 0;
	i = -6;
	while(i <= 6) {
		a = (pval+6)[i];
		if(a < 0)
			a -= 50; else
			a += 50;
		if(a < 0)
			a = -((-a)/100); else
			a /= 100;
		if(i)
			(pval+6)[i] = a*100-gval;
		i++;
	}
	a = 13800;
	i = 64;
	while(i--)
		a -= abs((pval+6)[board[i]]);
	if(a > 4000)
		game = 3; else
	if(a > 2000)
		game = 2; else
	if(moveno > 5)
		game = 1; else
		game = 0;
}

void
posit(register void (*f)(register int, register int *),
register int *p,
register int *a)
{
	register int m;

	while(amp != p) {
		m = amp[3]<<8;
		m |= amp[4]&0377;
		(*f)(m, a);
		if(mantom) {
			bmove(m);
			moveno++;
			mantom = 0;
		} else {
			wmove(m);
			mantom = 1;
		}
	}
}

void
rept1(register int m,
register int *a)
{
	register int i;

	if(mantom != a[64])
		return;
	for(i=0; i<64; i++)
		if(board[i] != a[i])
			return;
	a[65]++;
}

int
rept(void)
{
	int a[66];
	register int i, *p;

	for(i=0; i<64; i++)
		a[i] = board[i];
	a[64] = mantom;
	a[65] = 0;
	p = amp;
	while(amp[-1] != -1) {
		if(amp[-2])
			break;
		i = board[amp[-3]];
		if(i == 1 || i == -1)
			break;
		mantom? wremove(): bremove();
		decrem();
	}
	posit(rept1, p, a);
	return(a[65]);
}

void
rline(void)
{
	register char *p1;
	register int c;

lp:
	p1 = sbuf;
	printf("> ");
	while((c = fgetc(stdin)) != '\n')
		if(c <= 0){
			if(intrp){
				fputc('\n', stdout);
				intrp = 0;
				goto lp;
			}
			onhup();
		} else
			*p1++ = c;
	*p1++ = '\0';
}

void
pboard(void)
{
	register int i, x, y, c, p;

	c = 0;
	i = 0;
	x = 8;
	while(x--) {
		if(!mantom || mfmt)
			fputc('1'+x, stdout); else
			fputc('8'-x, stdout);
		fputc(' ', stdout);
		c++;
		y = 8;
		while(y--) {
			c++;
			fputc(' ', stdout);
			if(p = board[i++])
				fputc("kqrbnp PNBRQK"[p+6], stdout); else
				if((c&1)!=0)
					fputc('*', stdout); else
					fputc('-', stdout);
		}
		fputc('\n', stdout);
		if(intrp)
			return;
	}
	if(mfmt)
		printf("\n   a b c d e f g h"); else
		printf("\n   q q q q k k k k\n   r n b     b n r");
		printf("\n");
}

void
out1(register int m, register int *dummy)
{
	printf("%d. ", moveno);
	if(mantom)
		printf("... ");
	out(m);
	fputc('\n', stdout);
}

void
out(register int m)
{
	int from, to, epf, pmf;

	from = m>>8;
	to = m&0377;
	if(mfmt) {
		algco(from);
		algco(to);
		return;
	}
	mantom? bmove(m): wmove(m);
	epf = pmf = 0;
	switch(amp[-1]) {

	case 0:
	case 1:
		stdp(board[to]);
	ed:
		fputc('/', stdout);
		stdb(from);
		if(amp[-2]) {
			fputc('x', stdout);
			stdp(amp[-2]);
			fputc('/', stdout);
		} else
			fputc('-', stdout);
		stdb(to);
		break;

	case 3:
		fputc('o', stdout);
		fputc('-', stdout);

	case 2:
		fputc('o', stdout);
		fputc('-', stdout);
		fputc('o', stdout);
		break;

	case 4:
		epf = 1;
		fputc('p', stdout);
		goto ed;

	case 5:
		pmf = 1;
		fputc('p', stdout);
		goto ed;
	}
	if(pmf) {
		fputc('(', stdout);
		fputc('q', stdout);
		fputc(')', stdout);
	}
	if(epf) {
		fputc('e', stdout);
		fputc('p', stdout);
	}
	if(check())
		fputc('+', stdout);
	mantom? bremove(): wremove();
}

void
stdp(register int p)
{

	if(p < 0)
		p = -p;
	p = "ppnbrqk"[p];
	fputc(p, stdout);
}

void
stdb(register int b)
{
	register int r, f;

	r = b/8;
	if((f = b%8) < 4)
		fputc('q', stdout); else {
		fputc('k', stdout);
		f = 7-f;
	}
	f = "rnb\0"[f];
	if(f)
		fputc(f, stdout);
	fputc(mantom? r+'1': '8'-r, stdout);
}

void
algco(register int p)
{
	fputc('a'+(p%8), stdout);
	fputc('8'-(p/8), stdout);
}

void
prtime(register int a,
register int b)
{
	printf("time = %d/%d\n", a, b);
}

void
score1(register int m, register int *dummy)
{
	if(intrp)
		return;
	if(!mantom)
		fprintf(stdout, "%2d. ", moveno);
	else
		fprintf(stdout, "\t\t");
	out(m);
	if(mantom)
		fputc('\n', stdout);
}

void
score(void)
{
	int *p;

	fputc('\n', stdout);
	p = amp;
	while(amp[-1] != -1) {
		mantom? wremove(): bremove();
		decrem();
	}
	posit(score1, p, /* Missing arg here! Use 0.... */ 0);
	fputc('\n', stdout);
}

int
mate(register int n,
register int f)
{
	register int a, b;

	mantom = !mantom;
	if(f == 0) {
		b = mater(n);
		mantom = !mantom;
		return(b);
	}
	b = 0;
	if(matflg) {
		a = 1;
		while(!mater(a)) {
			if(a >= n) {
				matflg = 0;
				return(0);
			}
			a++;
		}
		b = abmove;
		goto out;
	}
	a = n;
	while(mater(a)) {
		if(a == mdepth) {
			printf("Forced mate\n");
			matflg++;
		}
		b = abmove;
		if(a == 0)
			break;
		a--;
	}
out:
	mantom = !mantom;
	if(b) {
		abmove = b;
		return(1);
	}
	return(0);
}

int
mater(register int ns)
{
	register int *p1, *p2, *p3, f;

	if(intrp || --ns < 0)
		return(0);
	p1 = lmp;
	p2 = p1;
	p3 = p1;
	mantom? wgen(): bgen();
	while(p2 != lmp) {
		p2++;
		mantom? wmove(*p2): bmove(*p2);
		if((!mantom && !battack(wkpos) && wattack(bkpos)) ||
		  (mantom && !wattack(bkpos) && battack(wkpos))) {
			*p3 = *p2;
			p3++;
		}
		mantom? wremove(): bremove();
		p2++;
	}
	lmp = p3;
	p2 = p1;
	while(p2 != lmp) {
		mantom? wmove(*p2): bmove(*p2);
		f = xmater(ns);
		mantom? wremove(): bremove();
		if(f) {
			abmove = *p2;
			lmp = p1;
			return(1);
		}
		p2++;
	}
	lmp = p1;
	return(0);
}

int
xmater(register int ns)
{
	register int *p1, *p2, f;

	p1 = lmp;
	p2 = p1;
	mantom? bagen(): wagen();
	if(p2+2 == lmp && rept() == 0)
		ns++;
	while(p2 != lmp) {
		p2++;
		mantom? bmove(*p2): wmove(*p2);
		f = mater(ns);
		mantom? bremove(): wremove();
		if(!f) {
			lmp = p1;
			return(0);
		}
		p2++;
	}
	lmp = p1;
	return(1);
}

void
play(register int f)
{
	register int t, i;

	chessclock();
	if(f) goto first;
loop:
	intrp = 0;
	move();

first:
	if(manflg)
		goto loop;
	i = mantom;
	t = clktim[i];
	if(!bookm())
	if(!mate(mdepth, 1))
		xplay();
	if(intrp) {
		decrem();
		mantom? bremove(): wremove();
		goto loop;
	}
	if(!abmove) {
		printf("Resign\n");
		onhup();
	}
	makmov(abmove);
	i = clktim[i];
	t = i-t;
	if(i/moveno > 150) {
		if(depth > 1)
			goto decr;
		goto loop;
	}
	if(depth==3 && t>180)
		goto decr;
	if(depth==1 && t<60)
		goto incr;
	if(game==3 && t<60 && depth==2)
		goto incr;
	goto loop;

incr:
	depth++;
	goto loop;

decr:
	goto loop;
}

void
move(void)
{
	register int a, *p, *p1;

loop:
	lmp = done();
	a = manual();
	p = done();
	p1 = p;
	while(p1 != lmp) {
		p1++;
		if(*p1++ == a) {
			lmp = p;
			makmov(a);
			return;
		}
	}
	printf("Illegal move\n");
	lmp = p;
	goto loop;
}

int
manual(void)
{
	register int a, b, c;
	char *p1;

loop:
	intrp = 0;
	stage();
	rline();
	sbufp = sbuf;
	if (match("self")) { play(1); }
	if(match("save")) {
		save();
		goto loop;
	}
	if(match("test")) {
		testf = !testf;
		goto loop;
	}
	if(match("remove")) {
		if(amp[-1] != -1) {
			decrem();
			mantom? bremove(): wremove();
		}
		if(amp[-1] != -1) {
			decrem();
			mantom? bremove(): wremove();
		}
		goto loop;
	}
	if(match("exit"))
		exit(0);
	if(match("manual")) {
		manflg = !manflg;
		goto loop;
	}
	if(match("resign"))
		onhup();
	if(moveno == 1 && mantom == 0) {
		if(match("first"))
			play(1);
		if(match("alg")) {
			mfmt = 1;
			goto loop;
		}
		if(match("restore")) {
			restore();
			goto loop;
		}
	}
	if(match("clock")) {
		clktim[mantom] += chessclock();
		mytime("white", clktim[0]);
		mytime("black", clktim[1]);
		goto loop;
	}
	if(match("score")) {
		score();
		goto loop;
	}
	if(match("setup")) {
		setup();
		goto loop;
	}
	if(match("hint")) {
		a = xplay();
		out(abmove);
		printf(" %d\n", a);
		goto loop;
	}
	if(*sbufp == '\0') {
		pboard();
		goto loop;
	}
	if((a=algin()) != 0) {
		mfmt = 1;
		return(a);
	}
	if((a=std_in()) != 0) {
		mfmt = 0;
		return(a);
	}
	printf("eh?\n");
	goto loop;
}

int
algin(void)
{
	register int from, to;

	from = cooin();
	to = cooin();
	if(*sbufp != '\0') return(0);
	return((from<<8)|to);
}

int
cooin(void)
{
	register int a, b;

	a = sbufp[0];
	if(a<'a' || a>'h') return(0);
	b = sbufp[1];
	if(b<'1' || b>'8') return(0);
	sbufp += 2;
	a = (a-'a')+8*('8'-b);
	return(a);
}

int
match(register char *s)
{
	register char *p1;
	register int c;

	p1 = sbufp;
	while((c = *s++) != '\0')
		if(*p1++ != c) return(0);
	sbufp = p1;
	return(1);
}

int *
done(void)
{
	register int *p;

	if(rept() > 3) {
		printf("Draw by repetition\n");
		onhup();
	}
	p = lmp;
	mantom? bagen(): wagen();
	if(p == lmp) {
		if(check())
			if(mantom)
				printf("White wins\n"); else
				printf("Black wins\n"); else
		printf("Stale mate\n");
		onhup();
	}
	return(p);
}

int
xplay(void)
{
	register int a;

	stage();
	abmove = 0;
	a = mantom? bplay(): wplay();
	ivalue = a;
	return(a);
}

void
term(void)
{
	exit(0);
}


void
mysort(register struct obj *p1,
register struct obj *p2)
{
	register struct obj *s, *t;
	register int x;

	for(s = p1; s < p2; s++){
		for(t = s+1; t < p2; t++){
			if(t->o_1 < s->o_1){
				x = t->o_1;
				t->o_1 = s->o_1;
				s->o_1 = x;
				x = t->o_2;
				t->o_2 = s->o_2;
				s->o_2 = x;
			}
		}
	}
}

void
save(void)
{
	int i;
	int f;

	f = creat("chess.out", 0666);
	if(f < 0) {
		printf("Can not create 'chess.out' save file\n");
		return;
	}
	write(f, clktim, (sizeof (int))*2);
	write(f, &bookp, 2);
	write(f, &moveno, sizeof (int));
	write(f, &game, sizeof (int));
	i = amp-ambuf;
	write(f, &i, sizeof (int));
	write(f, &mantom, sizeof (int));
	write(f, &value, sizeof (int));
	write(f, &ivalue, sizeof (int));
	write(f, &depth, sizeof (int));
	write(f, &flag, sizeof (int));
	write(f, &eppos, sizeof (int));
	write(f, &bkpos, sizeof (int));
	write(f, &wkpos, sizeof (int));
	write(f, board, 64*(sizeof (int)));
	write(f, ambuf, i*(sizeof (int)));
	close(f);
}

void
restore(void)
{
	int i;
	int f;

	f = open("chess.out", 0);
	if(f < 0) {
		printf("Can not open restore file 'chess.out'\n");
		return;
	}
	read(f, clktim, 2*(sizeof (int)));
	read(f, &bookp, 2);
	read(f, &moveno, sizeof (int));
	read(f, &game, sizeof (int));
	read(f, &i, sizeof (int));
	amp = ambuf+i;
	read(f, &mantom, sizeof (int));
	read(f, &value, sizeof (int));
	read(f, &ivalue, sizeof (int));
	read(f, &depth, sizeof (int));
	read(f, &flag, sizeof (int));
	read(f, &eppos, sizeof (int));
	read(f, &bkpos, sizeof (int));
	read(f, &wkpos, sizeof (int));
	read(f, board, 64*(sizeof (int)));
	read(f, ambuf, i*(sizeof (int)));
	close(f);
}

void
setup(void)
{
	char bd[64];
	char *p, *ip;
	int i, err, nkng, c;
	int wkp, bkp;

	for(p=bd; p<bd+64; )
		*p++ = 0;
	err = 0;
	nkng = 101;
	p = bd;
	for(i=0; i<8; i++) {
		ip = p+8;

	loop:
		switch(c = getchar()) {

		case 'K':
			nkng -= 100;
			c = 6;
			bkp = p-bd;
			break;

		case 'k':
			nkng--;
			c = -6;
			wkp = p-bd;
			break;

		case 'P':
			c = 1;
			break;

		case 'p':
			c = -1;
			break;

		case 'N':
			c = 2;
			break;

		case 'n':
			c = -2;
			break;

		case 'B':
			c = 3;
			break;

		case 'b':
			c = -3;
			break;

		case 'R':
			c = 4;
			break;

		case 'r':
			c = -4;
			break;

		case 'Q':
			c = 5;
			break;

		case 'q':
			c = -5;
			break;

		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
			p += c-'0';
			goto loop;

		case ' ':
			p++;
			goto loop;

		case '\n':
			if(p > ip)
				err++;
			p = ip;
			continue;

		default:
			err++;
			if(c <= 0)
				onhup();
			goto loop;
		}
		if(p < ip)
			*p++ = c;
		goto loop;
	}
	if(nkng)
		err++;
	if(err) {
		printf("Illegal setup\n");
		return;
	}
	for(i=0; i<64; i++)
		board[i] = bd[i];
	amp = ambuf+1;
	lmp = lmbuf+1;
	eppos = 64;
	bookp = 0;
	mantom = 0;
	moveno = 1;
	wkpos = wkp;
	bkpos = bkp;
	flag = 0;
	if(wkpos == 60) {
		if(board[56] == -4)
			flag |= 2;
		if(board[63] == -4)
			flag |= 1;
	}
	if(bkpos == 4) {
		if(board[0] == 4)
			flag |= 020;
		if(board[7] == 4)
			flag |= 010;
	}
	printf("Setup successful\n");
}


int *
statl(void)
{
	register int *p1, *p2, *p3;

	p1 = p2 = lmp;
	stage();
	mantom? bagen(): wagen();
	if(lmp == p1+1)
		return(p1);
	while(p2 != lmp) {
		p3 = p2++;
		if(mantom) {
			bmove(*p2++);
			*p3 = bstatic(0);
			bremove();
		} else {
			wmove(*p2++);
			*p3 = wstatic(0);
			wremove();
		}
	}
	mysort((struct obj *) p1, (struct obj *) lmp);
	return(p1);
}

int
wstatic(register int f)
{
	register int i, j, h;
	int (*p)();

	h = i = 0;
	while(p = wheur[h++]) {
		j = (*p)();
		if(f)
			printf("%4d ", j);
		i += j;
	}
	if(f)
		printf("=%4d ", i);
	return(-i);
}

int
bstatic(register int f)
{
	register int i, j, h;
	int (*p)();

	h = i = 0;
	while(p = bheur[h++]) {
		j = (*p)();
		if(f)
			printf("%4d ", j);
		i += j;
	}
	if(f)
		printf("=%4d ", i);
	return(-i);
}

int
xheur(register int ploc)
{
	register int *p2, from, to, *p1, pie;

	pie = board[ploc];
	p1 = lmp;
	p2 = p1;
	mantom? wgen(): bgen();
	while(p2 != lmp) {
		p2++;
		to = *p2++ & 0377;
		if(to == ploc) {
			from = p2[-1] >> 8;
			if(abs(board[from]) < abs(pie)) {
				lmp = p1;
				return((pval+6)[pie]/60);
			}
		}
	}
	lmp = p1;
	return(0);
}

void
srnd(register int p)
{

	srnd1(p, uleft, -9);
	srnd1(p, uright, -7);
	srnd1(p, dleft, 7);
	srnd1(p, dright, 9);
	srnd1(p, up, -8);
	srnd1(p, left, -1);
	srnd1(p, right, 1);
	srnd1(p, down, 8);
	srnd1(p, 0, 0);
}

void
srnd1(register int p,
register int m,
register int o)
{

	if((dir[p]&m) == 0)
		control[p+o] += 10;
}

int
std_in(void)
{
	int piece1, piece2, side1, side2, rnk1, rnk2, file1, file2;
	int ckf, c, m, *p1, *p2, to, amb, piece;

	piece1 = piece2 = side1 = side2 = -1;
	rnk1 = rnk2 = file1 = file2  = -1;
	ckf = 0;
	if(match("o-o-o")||match("ooo")) {
		piece1 = 6;
		file1 = 3;
		side1 = 1;
		file2 = 2;
		side2 = 0;
		goto search;
	}
	if(match("o-o")||match("oo")) {
		piece1 = 6;
		file1 = 3;
		file2 = 1;
		goto search;
	}
	stdpin(&piece1, &side1, &rnk1, &file1);
	c = *sbufp++;
	if(c=='*' || c=='x')
		stdpin(&piece2, &side2, &rnk2, &file2); else
	if(c == '-')
		stdbin(&side2, &rnk2, &file2); else
		sbufp--;

search:
	c = *sbufp++;
	if(c == '+') {
		ckf = 1;
		c = *sbufp++;
	}
	if(c != '\0')
		return(0);

	p1 = p2 = lmp;
	mantom? bagen(): wagen();
	m = -1;
	amb = 0;
	while(p1 != lmp) {
		p1++;
		piece = board[*p1>>8];
		mantom? bmove(*p1): wmove(*p1);
		to = amp[-3];
		if(pcomp(piece, amp[-4],
			piece1, side1, rnk1, file1))
		if(pcomp(amp[-2], to,
			piece2, side2, rnk2, file2))
		if(comp(ckf, check())) {
			if(m >= 0) {
				if(!amb) {
					printf("ambiguous\n");
					amb = 1;
				}
			}
			m = *p1;
		}
		p1++;
		mantom? bremove(): wremove();
	}
	lmp = p2;
	if(amb) return(-1);
	return(m);
}

void
stdpin(register int *ap,
register int *as,
register int *ar,
register int *af)
{
	register int c;

	c = *sbufp++;
	if(c == 'q') {
		*as = 0;
		stdpin(ap, as, ar, af);
		return;
	}
	if(c == 'k') {
		*as = 1;
		stdpin(ap, as, ar, af);
		return;
	}
	if(c == 'p') {
		*ap = 1;
		if(*as >= 0)
			*af = 3;
		goto loc;
	}
	if(c == 'n') {
		*ap = 2;
		goto pie;
	}
	if(c == 'b') {
		*ap = 3;
		goto pie;
	}
	if(c == 'r') {
		*ap = 4;
		goto pie;
	}
	sbufp--;
	goto loc;

pie:
	if(*sbufp == 'p') {
		*af = (*ap-1)%3;
		*ap = 1;
		sbufp++;
	}

loc:
	if(*ap<0 && *as>=0) {
		*ap = *as+5;
		*as = -1;
	}
	if(*sbufp == '/') {
		sbufp++;
		stdbin(as, ar, af);
	}
}

void
stdbin(register int *as,
register int *ar,
register int *af)
{
	register int c;

loop:
	c = *sbufp++;
	if(c == 'q') {
		*as = 0;
		goto kq;
	}
	if(c == 'k') {
		*as = 1;
	kq:
		stdbin(as, ar, af);
		if(*af < 0)
			*af = 3;
		return;
	}

	if(c == 'r') {
		*af = 0;
		goto loop;
	}
	if(c == 'n') {
		*af = 1;
		goto loop;
	}
	if(c == 'b') {
		*af = 2;
		goto loop;
	}
	if(c>'0' && c<'9')
		*ar = c-'1'; else
		sbufp--;
}

int
pcomp(register int p,
register int l,
register int pp,
register int sp,
register int rp,
register int fp)
{
	int r, f, s;

	f = l%8;
	r = l/8;
	if(!mantom)
		r = 7-r;
	if(f > 3) {
		f = 7-f;
		s = 1;
	} else
		s = 0;

	if(comp(pp, p))
	if(comp(sp, s))
	if(comp(rp, r))
	if(comp(fp, f))
		return(1);
	return(0);
}

int
comp(register int p,
register int v)
{

	if(p < 0) return(1);
	return(p == abs(v));
}

int
abs(register int x)
{

	if(x < 0)
		return(-x);
	return(x);
}

#undef	PAWN
#undef	KNIGHT
#undef	BISHOP
#undef	ROOK
#undef	QUEEN
#undef	KING

#define	PAWN	-1
#define	KNIGHT	-2
#define	BISHOP	-3
#define	ROOK	-4
#define	QUEEN	-5
#define	KING	-6

void
w_try(register int m,
register int o)
{
	register int j;

	if((*pd_wgen & m) == 0 && (j = pb_wgen[o]) >= 0){
		*lmp++ = value - (pval+6)[j];
		*lmp++ = (o + i_wgen) | (i_wgen << 8);
		}
	}

void
wslide(register int m,
register int o)
{
	register int *spb = pb_wgen;
	register int *spd = pd_wgen;

	while((*pd_wgen & m) == 0){
		register int t;
		pb_wgen += o;
		pd_wgen += o;
		if((t = *pb_wgen) < 0) break;
		if(t > 0){
			*lmp++ = value - (pval+6)[t];
			*lmp++ = (pb_wgen-board) | (i_wgen << 8);
			break;
			}
		*lmp++ = value;
		*lmp++ = (pb_wgen-board) | (i_wgen << 8);
		}
	pb_wgen = spb, pd_wgen = spd;
	}

void
wgen(void)
{
	pd_wgen = &dir[63];
	pb_wgen = &board[63];
	i_wgen = 63;
	while(i_wgen >= 0){
		switch(*pb_wgen){
		case PAWN:
			if((*pd_wgen & uleft) == 0){
				if(pb_wgen[-9] > 0)
					w_try(0, -9);
				if(i_wgen - 9 == eppos)
					w_try(0, -1);
			}
			if((*pd_wgen & uright) == 0){
				if(pb_wgen[-7] > 0)
					w_try(0, -7);
				if(i_wgen - 7 == eppos)
					w_try(0, 1);
			}
			if(pb_wgen[-8])
				break;
			w_try(0, -8);
			if((*pd_wgen & rank2) && (pb_wgen[-16] == 0))
				w_try(0, -16);
			break;
	
		case KNIGHT:
			w_try(u2r1, -15);
			w_try(u1r2, -6);
			w_try(d1r2, 10);
			w_try(d2r1, 17);
			w_try(d2l1, 15);
			w_try(d1l2, 6);
			w_try(u1l2, -10);
			w_try(u2l1, -17);
			break;
	
		case BISHOP:
			wslide(uleft, -9);
			wslide(uright, -7);
			wslide(dleft, 7);
			wslide(dright, 9);
			break;
	
		case QUEEN:
			wslide(uleft, -9);
			wslide(uright, -7);
			wslide(dleft, 7);
			wslide(dright, 9);
			/* Fall through... */
		case ROOK:
			wslide(up, -8);
			wslide(left, -1);
			wslide(right, 1);
			wslide(down, 8);
			break;
	
		case KING:
			w_try(uleft, -9);
			w_try(uright, -7);
			w_try(dleft, 7);
			w_try(dright, 9);
			w_try(up, -8);
			w_try(left, -1);
			w_try(right, 1);
			w_try(down, 8);
			break;
	
		default:
			if(*pb_wgen < 0){
				printf("wgen(): bad piece = %d\n", *pb_wgen);
				abort();
			}
			break;
		}
		pb_wgen--;
		pd_wgen--;
		i_wgen--;
	}
	return;
}


/*
 *	mobility
 *	1 for each potential move
 */

int
wheur1(void)
{
	register int *p1, *p2, *p3, i;
	int pto;

	if(amp[-2]) {
		i = amp[-3];
		pto = board[i];
		board[i] = 0;
	}
	p1 = lmp;
	wgen();
	p2 = lmp;
	lmp = p1;
	bgen();
	p3 = lmp;
	lmp = p1;
	i = p2-p3;
/*	Another fix: >> may be unsigned; if so, use / */
#ifdef	ASR
	i >>= 1;
#else
	i /= 2;
#endif
	if(amp[-2])
		board[amp[-3]] = pto;
	return(i);
}

/*
 *	opening 'goodies'
 */

int
wheur2(void)
{
	register int i;

	i = 0;
	if(game > 2) return(i);
	/*
	 * minor pieces out
	 * knights before bishops
	 */
	i += 9*((board[57] != -2)+
		(board[62] != -2));
	i += 8*((board[58] != -3)+
		(board[61] != -3));
	/*
	 * blocked central pawns
	 */
	if(board[51] == -1 && board[51-8]!=0) i -= 10;
	if(board[52] == -1 && board[52-8]!=0) i -= 10;
	return(i);
}

/*
 *	castle
 */

int
wheur3(void)
{
	register int i;

	i = 0;
	/*
	 * queenside ability
	 */
	if(flag&02 && board[48]== -1 && board[49]== -1 && board[50]== -1)
		i += 20;
	/*
	 *  kingside ability
	 */
	if(flag&01 && board[53]== -1 && board[54]== -1 && board[55]== -1)
		i += 20;
	/*
	 * if both
	 */
	if(i == 40)
		i = 22;
	/*
	 * if castled,
	 * keep pawns in
	 */
	if(wkpos==58)
		if(board[50]== -1 && (board[48]== -1 || board[48-8]== -1) &&
			(board[49]== -1 || board[49-8]== -1))
				i += 40;
	if(wkpos==62)
		if(board[53]== -1 && (board[54]== -1 || board[54-8]== -1) &&
			(board[55]== -1 || board[55-8]== -1))
				i += 40;
	return(i);
}

/*
 *	prance
 *	a percentage if the
 *	piece on the move
 *	can be driven back
 *	by a smaller piece
 */

int
wheur4(void)
{
	register int *p1, *p2, ploc, i;

	if(amp[-1] != 1) return(0);
	ploc = amp[-3];
	if(board[ploc] == -1) return(0);
	if(xheur(ploc)) return(0);
	p1 = lmp;
	p2 = p1;
	bagen();
	i = 0;
	while(p2 != lmp) {
		p2++;
		bmove(*p2++);
		i = xheur(ploc);
		bremove();
		if(i)
			break;
	}
	lmp = p1;
	return(i);
}

/*
 *	control
 *	center control
 *		opening
 *		beginning
 *	king control
 *		middle
 *		end
 */

int
wheur5(void)
{
	register int i, j, k;
	register int s, n, d, pto;

	if(amp[-2]) {
		i = amp[-3];
		pto = board[i];
		board[i] = 0;
	}
	i = 64;
	while(i--)
		control[i] = 0;
	if(game < 2) {
		i = 64;
		while(i--)
			control[i] += center[i];
	}
	if(mantom) {
		if((flag&03)==0)
			srnd(wkpos);
	} else {
		if((flag&030)==0)
			srnd(bkpos);
	}
	i = 64;
	s = 0;
	while(i--) {
		n = control[i]*100;
		attack(i);
		j = 0;
		while(k = attacv[j++]) {
			d = (pval+6)[k];
			if(d < 0)
				s -= n/(-d); else
				s += n/d;
		}
	}
	if(amp[-2])
		board[amp[-3]] = pto;
	return(-s);
}

/*
 * mate threat
 * minus for captures
 */

int
wheur6(void)
{
	register int i;

	i = 0;
	*amp++ = -1;
	if(wattack(bkpos))
		if(mate(2, 0))
			i += 15;
	amp--;
	return(i);
}


#define	PAWN	-1
#define	KNIGHT	-2
#define	BISHOP	-3
#define	ROOK	-4
#define	QUEEN	-5
#define	KING	-6

void
wmove(register int pos)
{
	register int *pa;
	register int to, from;

	to = pos & 0377;
	from = (pos >> 8) & 0377;
	pa = amp;
	*pa++ = value;
	*pa++ = flag;
	*pa++ = eppos;
	*pa++ = from;
	*pa++ = to;
	if(*pa++ = board[to])
		value -= (pval+6)[board[to]];
	board[to] = board[from];
	board[from] = 0;
	eppos = -1;
	switch(board[to]){
	default:
		printf("wmove(): piece moved = %d\n", board[to]);
		abort();
	case PAWN:
		if((from -= to) < 0)
			from = -from;
		if(from == 1){
			board[to] = 0;
			(board-8)[to] = PAWN;
			*pa++ = 4;
			amp = pa;
			return;
		}
		if(from == 16){
			eppos = ((pos >> 8) & 0377) - 8;
			goto move;
		}
		if(to >= 24)
			goto move;
		value -= 25;
		if(to >= 16)
			goto move;
		value -= 50;
		if(to >= 8)
			goto move;
		value -= 625;
		board[to] = QUEEN;
		*pa++ = 5;
		amp = pa;
		return;

	case ROOK:
		if(from == 63)
			flag &= ~01;
		else if(from == 56)
			flag &= ~02;
		goto move;

	case KING:
		wkpos = to;
		flag &= ~03;
		if(from == 60){
			if(to == 62){
				value--;
				board[61] = ROOK;
				board[63] = 0;
				*pa++ = 2;
				amp = pa;
				return;
			}
			if(to == 58){
				value--;
				board[59] = ROOK;
				board[56] = 0;
				*pa++ = 3;
				amp = pa;
				return;
			}
		}
		if(game == 0)
			value += 2;
		*pa++ = 0;
		amp = pa;
		return;

	case QUEEN:
		if(game == 0)
			value++;
		/* Fall through */

	case KNIGHT:
	case BISHOP:
		{ move: ; }
		*pa++ = 1;
		amp = pa;
		return;
	}
}

void
wremove(void)
{
	register int *pa;
	register int to, from;
	int i;
	int oldpiece;

	pa = amp;
	i = *--pa;
	oldpiece = *--pa;
	to = *--pa;
	from = *--pa;
	eppos = *--pa;
	flag = *--pa;
	value = *--pa;
	amp = pa;
	board[from] = board[to];
	board[to] = oldpiece;
	switch(i){
	case 0:
		wkpos = from;
	case 1:
		return;
	case 2:
		board[63] = ROOK;
		board[61] = 0;
		wkpos = 60;
		return;
	case 3:
		board[56] = ROOK;
		board[59] = 0;
		wkpos = 60;
		return;
	case 4:
		board[from] = PAWN;
		(board-8)[to] = 0;
		return;
	case 5:
		board[from] = PAWN;
		return;
	default:
		printf("Barfo in wremove -- type %d\n", i);
		abort();
	}
}

int
wplay(void)
{
	register int *p2, v1, v2, *p3, *p1, ab;

	if(value < ivalue)
		ivalue = value;
	ab = 0;
	v1 = 3000;
	ply = 0;
	p1 = statl();
	if(lmp == p1+2) {
		abmove = p1[1];
		lmp = p1;
		return(ivalue);
	}
	p2 = p1;
	mantom = !mantom;
	while(p2 != lmp) {
		p2++;
		wmove(*p2);
		if(testf) {
			mantom = !mantom;
			wstatic(1);
			mantom = !mantom;
		}
		if(rept())
			v2 = 0; else
			v2 = bplay1(v1);
		if(v2 < v1 && !mate(3, 0)) {
			ab = *p2;
			v1 = v2;
		}
		wremove();
		if(testf) {
			mantom = !mantom;
			printf("%6d ", v2);
			out(*p2);
			printf("\n");
			mantom = !mantom;
		}
		p2++;
	}
	if(ab == 0 && lmp != p1)
		ab = p1[1];
	mantom = !mantom;
	lmp = p1;
	abmove = ab;
	return(v1);
}

int
wplay1(register int ab)
{
	register int *p2, v1, v2, *p1;

	if(ply >= depth)
		return(wquies(ab));
	ply++;
	p1 = p2 = lmp;
	wgen();
	mysort((struct obj *) p1, (struct obj *) lmp);
	v1 = 3000;
	while(p2 != lmp) {
		if(intrp)
			goto out;
		p2++;
		wmove(*p2);
		if(battack(wkpos)) {
			v2 = bplay1(v1);
			if(v2 < v1)
				v1 = v2;
		}
		wremove();
		if(v1 <= ab)
			goto out;
		p2++;
	}
out:
	ply--;
	lmp = p1;
	if(v1 == 3000) {
		v1--;
		if(!check())
			v1 = 0;
	}
	return(v1);
}

int
wquies(register int ab)
{
	register int *p1, *p2, *p3, v1, v2;

	if(ply >= qdepth)
		return(ivalue);
	p1 = p2 = p3 = lmp;
	wgen();
	while(p2 != lmp) {
		v1 = *p2++;
		if(v1 != value && v1 <= ivalue+50) {
			*p3++ = (((pval+6)[board[*p2>>8]]/100)<<8) |
				(-(pval+6)[board[*p2&0377]]/100);
			*p3++ = *p2;
		}
		p2++;
	}
	if(p3 == p1) {
		lmp = p1;
		return(value);
	}
	ply++;
	mysort((struct obj *) p1, (struct obj *) p3);
	lmp = p3;
	p2 = p1;
	v1 = value;
	while(p2 != lmp) {
		p2++;
		wmove(*p2);
		if(battack(wkpos)) {
			v2 = bquies(v1);
		} else
			v2 = 3000;
		if(v2 < v1)
			v1 = v2;
		wremove();
		if(v1 <= ab)
			goto out;
		p2++;
	}
out:
	ply--;
	lmp = p1;
	return(v1);
}
